﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using Syncfusion.Mvc.DocIO.Web;
using System.Drawing;
using System.IO;
using System.Data;
using System.Data.SqlServerCe;
using System.Data.OleDb;
using System.Net;

namespace GenerateWord.Controllers
{
    public class HomeController : Controller
    {
        string dataPath;
        #region Generate Word
        public ActionResult Index(string Group1)
        {
            if (Group1 == null)
                return View();

            dataPath = ResolveApplicationDataPath("", "Data");
            WordDocument document = new WordDocument();
            document.Open(Path.Combine(dataPath, "Template.docx"), FormatType.Docx);
            //Uses the mail merge events handler for image fields
            document.MailMerge.MergeImageField += new MergeImageFieldEventHandler(MergeField_ProductImage);
            //Specifies the field names and field values
            string[] fieldNames = new string[] { "SyncfusionLogo" };
            string[] fieldValues = new string[] { "syncfusion_logo.png" };
            //Executes the mail merge with groups
            document.MailMerge.Execute(fieldNames, fieldValues);

            #region saveOption
            if (Group1 == "Word97To2003")
            {
                //Save as .doc Word 97-2003 format
                return document.ExportAsActionResult("Sample.doc", FormatType.Doc, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            //Save as .docx Word 2007 format
            else if (Group1 == "Word2007")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2007, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            //Save as .docx Word 2010 format
            else if (Group1 == "Word2010")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2010, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            //Save as .docx Word 2013 format
            else if (Group1 == "Word2013")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2013, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            #endregion saveOption

            return View();
        }
        #endregion Getting Started
        /// <summary>
        /// Data folder path is resolved from requested page physical path
        /// </summary>
        /// <param name="fileName"></param>
        /// <param name="folderName"></param>
        /// <returns></returns>
        protected string ResolveApplicationDataPath(string fileName, string folderName)
        {
            string dataPath = null;
            dataPath = Server.MapPath(@"App_Data//Images").ToString();
            return string.Format("{0}\\{1}", dataPath, fileName);
        }
        private void MergeField_ProductImage(object sender, MergeImageFieldEventArgs args)
        {
            //Binds image from file system during mail merge

            if (args.FieldName == "SyncfusionLogo")
            {
                WPicture picture = new WPicture(args.Document);
                picture.LoadImage(Image.FromFile(Path.Combine(dataPath, "syncfusion_logo.png")));
                //Appending hyperlink for the owner paragraph
                //Added web link to the merge field
                args.CurrentMergeField.OwnerParagraph.AppendHyperlink(@"https://help.syncfusion.com/file-formats/docio/working-with-mailmerge#event-support-for-mail-merge", picture, HyperlinkType.WebLink);                
            }

        }
    }
}
